; CH_EPAI

; =========================================
; changer les entits lignes,arc,cercles et polylignes
; pour leur donner une epaisseur
; =========================================



(defun *error* (s)
(alert msg)
(princ)
)


(defun c:ch_epai ()

(setq ent nil)

(setvar "cmdecho" 0)

(initget 3 "C P O")
(setq selec (getkword "\nSlection par Couleur/Plan/Objets: "))

(cond 

        ((= selec "C")
        (initget  "S C")
        (setq def (getkword "\nSlection d'une couleur sur objet/<Code de la Couleur>: "))
                (if (= def "S")
                (module_coul)
                (progn
                (setq msg "\n>>> Le dessin ne comporte pas d'objet de cette COULEUR <<<")
                (initget 5)
                (setq def_coul (getint "\nCode de la couleur: "))
                (setq ent (ssget "x" (list (cons 62 def_coul))))
                )
                )
        )

        ((= selec "P")
        (initget  "S P")
        (setq def (getkword "\nSlection d'un plan sur objet/<Nom du Plan>: "))
                (if (= def "S")
                (module_plan)
                (progn
                (setq msg "\n>>> Le dessin ne comporte pas d'objet de ce PLAN <<<")
                (setq def_plan (getstring "\nNom du plan: "))
                (setq ent (ssget "x" (list (cons 8 def_plan))))
                )
                )
        )

        ((= selec "O")
        (initget "A C L P S")
        (setq def (getkword "\nSlection/Arc/Cercle/Ligne/Polyligne: "))
        (module_obj)
        )

); cond


(if (= ent nil)
(alert msg)
(progn
(setq nb_ent (sslength ent))


(if (= nb_ent 1)
(princ "\n1 objet slectionn.")
(princ (strcat "\n" (itoa nb_ent) " objets slectionns."))
)

(initget 5)
(setq ep (getreal "\nEpaisseur  donner: "))


(setq compte 0)


(repeat nb_ent

(princ (strcat "\rTraitement : " (itoa (1+ compte)) " sur " (itoa nb_ent) "         "))

(setq pl nil co nil tl nil)

(setq obj (cdr (assoc 0 (entget (ssname ent compte)))))

(cond

        ((or (= obj "LINE") (= obj "ARC"))
        (command "pedit" (ssname ent compte) "o" "e" ep "s")
        )

        ((= obj "POLYLINE")
        (if (= (cdr (assoc 70 (entget (ssname ent compte)))) 0)
                (command "pedit" (ssname ent compte) "e" ep "s")
                (command "pedit" (ssname ent compte) "e" ep "c" "s")
        )
        )

        ((= obj "CIRCLE")
        (setq pl (cdr (assoc 8 (entget (ssname ent compte)))))
        (setq co (cdr (assoc 62 (entget (ssname ent compte)))))
        (setq tl (cdr (assoc 64 (entget (ssname ent compte)))))
        (setq ray (rtos (cdr (assoc 40 (entget (ssname ent compte)))) 2 3))
        (setq dia (rtos (* (cdr (assoc 40 (entget (ssname ent compte)))) 2) 2 3))
        (setq cen (cdr (assoc 10 (entget (ssname ent compte)))))
        
        (entdel (ssname ent compte))
        
        (setvar "lastpoint" cen)
        
        (setq derunit (getvar "aunits"))
        
        (setvar "aunits" 0)
        (command "arc" (strcat "@" ray "<<0")
                       "c" cen
                       "a" 359.9

        ) 
       
        (command "chprop" (entlast) "" "_la" pl "")

        (if (/= co nil)
        (command "chprop" (entlast) "" "co" co "")
        )

        (if (/= tl nil)
        (command "chprop" (entlast) "" "tl" tl "")
        )

        
        (setvar "aunits" derunit)
        (command "pedit" (entlast) "o" "c" "e" ep "s") 
        )
)

(setq compte (1+ compte))
)

)
)

(princ "\nTravail termin.")

(princ)

)



; module de definition de la couleur

(defun module_coul ()

(setq msg "\n>>> Le dessin ne comporte pas d'objet de cette COULEUR <<<")

;(princ "\nSlectionnez une couleur sur un objet: ")
(setq ent_coul (car (entsel "\nSlectionnez une couleur par rapport  un objet: ")))

(if (/= (assoc 62 (entget ent_coul)) nil)
(setq code_coul (cdr (assoc 62 (entget ent_coul))))
(setq code_coul (cdr (assoc 62 
        (tblsearch "LAYER" (cdr (assoc 8 (entget ent_coul)))))))
);if

(if (= code_coul nil)
(error)
(setq ent (ssget "x" (list (cons 62 code_coul)))) 
)

)


; module de definition du plan

(defun module_plan ()

(setq msg "\n>>> Le dessin ne comporte pas d'objet de ce PLAN <<<")

;(princ "\nSlectionnez un plan sur un objet: ")
(setq ent_plan (car (entsel "\nSlectionnez un plan par rapport  un objet: ")))

(if (= ent_plan nil)
(error)
)

(setq ent (ssget "x" (list (cons 8 (cdr (assoc 8 (entget ent_plan))))))) 


)

; module pour selection par objet

(defun module_obj ()

(cond 

        ((= def "S")
        (setq ent (ssget))
        )

        ((= def "A")
        (princ "\nSlection par ARC")
        (setq ent (ssget "x" (list (cons 0 "ARC"))))
        (setq msg "\nLe dessin ne comporte pas ou plus d'objet ARC")
        )

        ((= def "C")
        (princ "\nSlection par CERCLE")
        (setq ent (ssget "x" (list (cons 0 "CIRCLE"))))
        (setq msg "\nLe dessin ne comporte pas ou plus d'objet CERCLE")
        )

        ((= def "L")
        (princ "\nSlection par LIGNE")
        (setq ent (ssget "x" (list (cons 0 "LINE"))))
        (setq msg "\nLe dessin ne comporte pas ou plus d'objet LIGNE")
        )

        ((= def "P")
        (princ "\nSlection par POLYLIGNE")
        (setq ent (ssget "x" (list (cons 0 "POLYLINE"))))
        (setq msg "\nLe dessin ne comporte pas ou plus d'objet POLYLIGNE")
        )

)

(princ)

)
(princ "\n==> CH_EPAI")
(princ)
